<?php
/**
 * mtwMigrator
 *
 * @author      Matias Aguirre
 * @email       maguirre@matware.com.ar
 * @url         http://www.matware.com.ar/
 * @license             GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

class mtwMigratorControllerConfig extends mtwMigratorController {
	
	public $_config = "";


	function __construct() {
		parent::__construct();

		jimport('joomla.filesystem.file');

		$configFile = JPATH_COMPONENT.DS.'mtwmigrator_config.php';
		if (JFile::exists( $configFile )) {
			include( $configFile );
			$this->_config = $mtwCFG;
		}

		$type = JRequest::getVar('type', 'config');

		$subMenus = array(
			'Server' => 'config',
			'Global' => 'global',
			'3rd Extensions' => '3rd');

/*
			'Joomla 1.0' => 'joomla10',
			'Joomla 1.5' => 'joomla15',
			'Drupal' => 'drupal',
			'RunCMS' => 'runcms'
 */


		//JSubMenuHelper::addEntry(JText::_( 'Global' ), '#" onclick="javascript:document.adminForm.type.value=\'\';submitbutton(\'extensions\');', !in_array( $task, $subMenus));
		foreach ($subMenus as $name => $extension) {
			//print($extension."-".$type."<br>");
			JSubMenuHelper::addEntry(JText::_( $name ), '#" onclick="javascript:document.adminForm.type.value=\''.$extension.'\';submitbutton(\''.$extension.'\');', $extension == $type ? 1 : 0);
		}    

		// Register Extra tasks
		//$this->registerTask( 'add'  , 	'edit' );
	}

  function display() { 
  	$type = JRequest::getVar('type', 'config');
    JRequest::setVar( 'view', $type );
    //echo "DISPLAY:" . $type;

    parent::display();
  }

	function apply() {

		$model = $this->getModel('config');

		$data = JRequest::get( 'post' );

		if ($model->saveConfig($data)) {
			$msg = JText::_( 'Configuration Applied!' );
		} else {
			$msg = JText::_( 'Error Applying Configuration' );
		}

		JRequest::setVar( 'view', 'config' );

		$link = 'index.php?option=com_mtwmigrator&controller=config';
		$this->setRedirect($link, $msg);
	}

	/**
	 * save a record (and redirect to main page)
	 * @return void
	 */
	function save()
	{
		$model = $this->getModel('config');

		$data = JRequest::get( 'post' );

		if ($model->saveConfig($data)) {
			$msg = JText::_( 'Configuration Saved!' );
		} else {
			$msg = JText::_( 'Error Saving Configuration' );
		}

		$link = 'index.php?option=com_mtwmigrator';
		$this->setRedirect($link, $msg);
	}

	/**
	 * cancel editing a record
	 * @return void
	 */
	function cancel()
	{
		$msg = JText::_( 'Configuration Cancelled' );
		$this->setRedirect( 'index.php?option=com_mtwmigrator', $msg );
	}

}
?>
