<?php
/**
 * mtwMigrator
 *
 * @author      Matias Aguirre
 * @email       maguirre@matware.com.ar
 * @url         http://www.matware.com.ar/
 * @license             GNU/GPL
 */

// Check to ensure this file is included in Joomla!
defined('_JEXEC') or die();

/**
 * mtwMigratorControllerMigrate
 *
 * @package    mtwMigrator
 * @subpackage Components
 */
class mtwMigratorControllerMigrate extends mtwMigratorController
{

	public $_version = null;
	public $_config = null;

	function __construct() {
		parent::__construct();
		parent::registerDefaultTask('migrate');

		$xmlfile = JPATH_ADMINISTRATOR.DS."components".DS."com_languages".DS."languages.xml";
 		$xml = new JSimpleXML;
 		$xml->loadFile($xmlfile);
		$attrib = $xml->document->version[0];
		//echo $attrib->data();

		if($attrib->data() == "1.5.0"){
			$this->_version = "j15";
		}else if($attrib->data() == "1.6.0"){
			$this->_version = "j16";
		}

		jimport('joomla.filesystem.file');

		$configFile = JPATH_COMPONENT.DS.'mtwmigrator_config.php';
		if (JFile::exists( $configFile )) {
			include( $configFile );
			$this->_config = $mtwCFG;
		}

		// Register Extra tasks
		//$this->registerTask( 'add'  , 	'edit' );
	}


  function migrate(){
/*
		if ( $this->_version == "j16" ) {
	    $msg = JText::_( "Joomla 1.6 migrations is not supported yet" );
	    $link = 'index.php?option=com_mtwmigrator';
	    $this->setRedirect($link, $msg);
		}
*/
		$modelName = "{$this->_config['ver']}-{$this->_version}";

		//echo $modelName;

		//$model =& $this->getModel($modelName);

		include('components'.DS.'com_mtwmigrator'.DS.'models'.DS.$modelName.'.php' );
		
		//$data = VideosHelper::getData ( $url );
		
		$model = new mtwMigratorModelMigrate();

		//print_r($model);

		//echo $this->_version;

		if ( $model->_errors[0] ) {
	    $msg = JText::_( $model->_errors[0] );
	
	    $link = 'index.php?option=com_mtwmigrator';
	    $this->setRedirect($link, $msg);
		}

		JRequest::setVar( 'view', 'migrate' );
		parent::display();
  }

  function display() {
      
      JRequest::setVar( 'view', 'migrate' );
      
      parent::display();
  }
}
?>
